// Example how to use CUDOBJ.OBJ in C++
// written by Ys/CUD 02.07.97
// Link with CUDOBJ.OBJ

#include "conio.h"
#include "alloc.h"

extern "C" void far pascal cud_fm_player(void);
extern unsigned char far pascal Tempo;
extern unsigned char far pascal Speed;
extern unsigned char far pascal FM_Playing;
extern unsigned char far pascal FM_Row;
extern unsigned char far pascal FM_Pattern;
extern unsigned char far pascal FM_Track;
extern unsigned char far pascal FM_Repeat;
extern unsigned      far pascal FM_Count;
extern unsigned char far pascal FM_Note[27];
extern unsigned char far pascal FM_Peek[9];

struct FmInfo
{
 unsigned Tempo,Speed,Playing,Row,Pattern,Track,Repeat;
 unsigned Count;
 unsigned Note[27];
 unsigned Peek[9];
};

class Song
{
private:
 int status;
public:
 Song(char far* Name);
 Song(int handle);
 ~Song();
 int GetStatus(void) {return status;}
 void Reset(void);
 void Start(void);
 void Stop(void);
 void ReadFmInfo(FmInfo& fmi);
 void RedPeek(void);
};

Song::Song(char far* Name)
{
 void far* temp=farmalloc(0x1000F);
 if (!temp)
 {
  status=2;
  return;
 }
 _ES=(((unsigned long)temp)>>16)+((((unsigned)temp)+0xF)>>4);
 asm {
	push	ds
	lds	dx,Name
	xor	ax,ax
     }
 cud_fm_player();
 asm	pop	ds
 status=_FLAGS&1;
 farfree(temp);
}

Song::Song(int handle)
{
 void far* temp=farmalloc(0x1000F);
 if (!temp)
 {
  status=2;
  return;
 }
 _ES=(((unsigned long)temp)>>16)+((((unsigned)temp)+0xF)>>4);
 _BX=handle;
 _AX=1;
 cud_fm_player();
 status=_FLAGS&1;
 farfree(temp);
}

Song::~Song()
{
}

void Song::Reset(void)
{
 _AH=1;
 cud_fm_player();
 status=_FLAGS&1;
}

void Song::Start(void)
{
 _AH=2;
 cud_fm_player();
 status=_FLAGS&1;
}

void Song::Stop(void)
{
 _AH=3;
 cud_fm_player();
 status=_FLAGS&1;
}

void Song::ReadFmInfo(FmInfo& fmi)
{
 int z;
 fmi.Tempo=Tempo;
 fmi.Speed=Speed;
 fmi.Playing=FM_Playing;
 fmi.Row=FM_Row;
 fmi.Pattern=FM_Pattern;
 fmi.Track=FM_Track;
 fmi.Repeat=FM_Repeat;
 fmi.Count=FM_Count;
 for (z=0;z<27;z++)
  fmi.Note[z]=FM_Note[z];
 for (z=0;z<9;z++)
  fmi.Peek[z]=FM_Peek[z];
}

void Song::RedPeek(void)
{
 int z;
 for (z=0;z<9;z++)
 if (FM_Peek[z])
  FM_Peek[z]--;
}

int main(void)
{
 int z;
 FmInfo i;
 Song mySong("RAID.CFF");
 if (mySong.GetStatus())
 {
  return 1;
 }
 mySong.Reset();
 if (mySong.GetStatus())
 {
  return 1;
 }
 mySong.Start();
 clrscr();
 while (!kbhit())
 {
  gotoxy(1,1);
  mySong.ReadFmInfo(i);
  mySong.RedPeek();
  cprintf("Tempo:   %02X\n\r"
	  "Speed:   %02X\n\r"
	  "Playing:  %1X\n\r"
	  "Count: %4X\n\r"
	  "Row:     %2u\n\r"
	  "Pattern:%3u\n\r"
	  "Track:  %3u\n\r"
	  "Repeat:  %2u\n\r"
	  "Note:   ",
	  i.Tempo,i.Speed,i.Playing,i.Count,i.Row,i.Pattern,i.Track,i.Repeat);
  for (z=0;z<27;z++)
  {
   cprintf("%02X",i.Note[z]);
   if ((z%3)==2)
    putch(' ');
  }
  cprintf("\n\rPeek:   ");
  for (z=0;z<9;z++)
   cprintf("  %02X   ",i.Peek[z]);
  cprintf("\n\r");
 }
 getch();
 mySong.Stop();
 return 0;
}
